routes/web.php
    Route::resource('/member-tool-admin', 'MemberToolAdminController');
    Route::post('/member-tool-admin/search', 'MemberToolAdminController@search')->name('member-tool-admin.search');

    Route::resource('/tool-order-status', 'ToolOrderStatusController');
    Route::post('/tool-order-status/search', 'ToolOrderStatusController@search')->name('tool-order-status.search');

    Route::resource('/tool-order', 'ToolOrderController');
    Route::post('/tool-order/search', 'ToolOrderController@search')->name('tool-order.search');
    Route::get('/tool-order/invoice/{id}', 'ToolOrderController@invoice');
    Route::get('/tool-order-changestatus/{id}/{number}', 'ToolOrderController@changeorderstatus');

    Route::resource('/tool-status', 'ToolStatusController');
    Route::post('/tool-status/search', 'ToolStatusController@search')->name('tool-status.search');

    Route::resource('/onlinetool', 'OnlineToolController');
    Route::post('/onlinetool/search', 'OnlineToolController@search')->name('onlinetool.search');
    Route::get('/onlinetool/update/status', 'OnlineToolController@updatestatus');

    Route::resource('/onlinetoollog', 'OnlineToolLogController');
    Route::post('/onlinetoollog/search', 'OnlineToolLogController@search')->name('onlinetoollog.search');

    Route::resource('/leadadmin', 'LeadAdminController');
    Route::post('/leadadmin/searchnormal', 'LeadAdminController@searchnormal')->name('leadadmin.searchnormal');
    Route::post('/leadadmin/search', 'LeadAdminController@search')->name('leadadmin.search');
    Route::get('/leadadminchangstatus/{id}/{statusid}', 'LeadAdminController@changestatus');
    Route::get('/leadadminchangpriority/{id}/{number}', 'LeadAdminController@changepriority');

    Route::resource('/prospectadmin', 'ProspectAdminController');
    Route::get('/convert/prospectadmin/{id}', 'ProspectAdminController@convert');
    Route::post('/prospectadmin/searchnormal', 'ProspectAdminController@searchnormal')->name('prospectadmin.searchnormal');
    Route::post('/prospectadmin/search', 'ProspectAdminController@search')->name('prospectadmin.search');
    Route::get('/prospectadmin/status/{id}/{statusid}', 'ProspectAdminController@changestatus');
    Route::get('/prospectadmin/priority/{id}/{number}', 'ProspectAdminController@changepriority');
    Route::get('/prospectadmin/type/{id}/{number}', 'ProspectAdminController@changetype');

    Route::resource('/partnermanage', 'PartnerController');
    Route::post('/partnermanage/search', 'PartnerController@search')->name('partnermanage.search');

    Route::post('/partnerregister/search', 'PartnerController@search')->name('partnerregister.search');
    Route::get('/selectmember', 'PartnerController@selectmember');

    Route::get('/changestatuspartner/{statusid}/{pid}', 'PartnerController@changestatuspartner');
    Route::resource('/viewpartner', 'ViewpartnerController');
    Route::post('/viewpartner/search', 'ViewpartnerController@search')->name('viewpartner.search');

    Route::resource('/match-view-partner', 'MatchViewpartnerController');
    Route::post('/match-view-partner/search', 'MatchViewpartnerController@search')->name('match-view-partner.search');

    Route::resource('/partnergroup', 'PartnerGroupController');
    Route::post('/partnergroup/search', 'PartnerGroupController@search')->name('partnergroup.search');
    Route::resource('/match-partner-group', 'MatchPartnerGroupController');
    Route::post('/match-partner-group/search', 'MatchPartnerGroupController@search')->name('match-partner-group.search');

    Route::resource('/partnerstructure', 'PartnerStructureController');
    Route::post('/partnerstructure/search', 'PartnerStructureController@search')->name('partnerstructure.search');
    Route::resource('/partnerblock', 'PartnerBlockController');
    Route::post('/partnerblock/search', 'PartnerBlockController@search')->name('partnerblock.search');
    Route::resource('/partnerauth', 'PartnerAuthController');
    Route::post('/partnerauth/search', 'PartnerAuthController@search')->name('partnerauth.search');

    Route::resource('/case-category', 'CaseCategoryController');
    Route::post('/case-category/search', 'CaseCategoryController@search')->name('case-category.search');

    Route::resource('/case-type', 'CaseTypeController');
    Route::post('/case-type/search', 'CaseTypeController@search')->name('case-type.search');

    Route::resource('/case-middle-data-type', 'CaseMiddledataTypeController');
    Route::post('/case-middle-data-type/search', 'CaseMiddledataTypeController@search')->name('case-middle-data-type.search');

    Route::resource('/case-middle-data', 'CaseMiddledataController');
    Route::post('/case-middle-data/search', 'CaseMiddledataController@search')->name('case-middle-data.search');

    Route::resource('/cases', 'CasesController');
    Route::post('/cases/search', 'CasesController@search')->name('cases.search');

    Route::resource('/case-auth', 'CaseAuthController');
    Route::post('/case-auth/search', 'CaseAuthController@search')->name('case-auth.search');

    Route::resource('/procedures', 'ProceduresController');
    Route::post('/procedures/search', 'ProceduresController@search')->name('procedures.search');

    Route::resource('/stage', 'StageController');
    Route::get('/stage/detail/{id}', 'StageController@showStageDetail');

    Route::post('/stage/search', 'StageController@search')->name('stage.search');

    Route::resource('/process', 'ProcessController');
    Route::post('/process/search', 'ProcessController@search')->name('process.search');

    Route::resource('/procedures-to-process', 'ProceduresToProcessController');
    Route::post('/procedures-to-process/search', 'ProceduresToProcessController@search')->name('procedures-to-process.search');

    Route::resource('/path', 'PathController');
    Route::post('/path/search', 'PathController@search')->name('path.search');

    Route::resource('/conditiontype', 'ConditionTypeController');
    Route::post('/conditiontype/search', 'ConditionTypeController@search')->name('conditiontype.search');

    Route::resource('/condition', 'ConditionController');
    Route::post('/condition/search', 'ConditionController@search')->name('condition.search');

    Route::resource('/casecondition', 'CaseConditionController');
    Route::post('/casecondition/search', 'CaseConditionController@search')->name('casecondition.search');

    Route::resource('/pathcondition', 'PathConditionController');
    Route::post('/pathcondition/search', 'PathConditionController@search')->name('pathcondition.search');

    Route::resource('/proposal', 'ProposalController');
    Route::post('/proposal/search', 'ProposalController@search')->name('proposal.search');

    Route::resource('/offer-category', 'OfferCategoryController');
    Route::post('/offer-category/search', 'OfferCategoryController@search')->name('offer-category.search');

    Route::resource('/offertype', 'OfferTypeController');
    Route::post('/offertype/search', 'OfferTypeController@search')->name('offertype.search');

    Route::resource('/offer', 'OfferController');
    Route::post('/offer/search', 'OfferController@search')->name('offer.search');

    Route::resource('/campaign', 'CampaignController');
    Route::post('/campaign/search', 'CampaignController@search')->name('campaign.search');

    Route::resource('/promotion', 'PromotionController');
    Route::post('/promotion/search', 'PromotionController@search')->name('promotion.search');

    Route::resource('/action-category', 'ActionCategoryController');
    Route::post('/action-category/search', 'ActionCategoryController@search')->name('action-category.search');

    Route::resource('/action-type', 'ActionTypeController');
    Route::post('/action-type/search', 'ActionTypeController@search')->name('action-type.search');
    Route::resource('/stageaction', 'StageActionController');
    Route::post('/stageaction/search', 'StageActionController@search')->name('stageaction.search');
    Route::resource('/action', 'ActionController');
    Route::post('/action/search', 'ActionController@search')->name('action.search');

    Route::resource('/caseaction', 'CaseActionController');
    Route::post('/caseaction/search', 'CaseActionController@search')->name('caseaction.search');

    Route::resource('/caseproposal', 'CaseProposalController');
    Route::post('/caseproposal/search', 'CaseProposalController@search')->name('caseproposal.search');

    Route::resource('/pathconditiondetail', 'PathConditionDetailController');
    Route::post('/pathconditiondetail/search', 'PathConditionDetailController@search')->name('pathconditiondetail.search');

    Route::resource('/case-type-config', 'CaseTypeConfigController');
    Route::post('/case-type-config/search', 'CaseTypeConfigController@search')->name('case-type-config.search');

    Route::resource('/case-report', 'CaseReportController');
    Route::post('/case-report/search', 'CaseReportController@search')->name('case-report.search');

    Route::resource('/case-type-report', 'CaseTypeReportController');
    Route::post('/case-type-report/search', 'CaseTypeReportController@search')->name('case-type-report.search');

    Route::resource('/case-subtype', 'CaseSubTypeController');
    Route::post('/case-subtype/search', 'CaseSubTypeController@search')->name('case-subtype.search');

    Route::resource('/case-log', 'CaseLogController');
    Route::post('/case-log/search', 'CaseLogController@search')->name('case-log.search');

    Route::post('/updatepathcondition', 'CaseAjaxController@updatepathcondition');
    Route::post('/createactiontostage', 'CaseAjaxController@createactiontostage');

    Route::get('/deleteaction', 'StageController@deleteaction');

    Route::resource('/case-status', 'CaseStatusController');
    Route::post('/case-status/search', 'CaseStatusController@search')->name('case-status.search');

    Route::resource('/case-channel', 'CaseChannelController');

app/Http/Controllers/MatchPartnerGroupController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Response;
use Illuminate\Support\Facades\Auth;
use App\View;
use App\Block;
use App\member;
use App\Partner;
use App\Partner_group;
use App\match_partner_group;
use App\Http\Controllers\SidebarController;
class MatchPartnerGroupController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('view');
    }
	     public function getArrayAlldBlock($currentstruc,$currentid,$notebook){

    $CurrentDivisions = Block::where('id', '=',$currentid )->get();
    $result =$notebook;
    $ChildDivisions = Block::whereIn('under_block',$currentid )->pluck('id');
    foreach ( $ChildDivisions as $Division => $get) {
      $nextblockID[$Division] = $get;
      $arraylength = sizeof($result);
      //$currentid=$currentid;
      $result[$arraylength]  = $nextblockID[$Division];
      $result = $this->getArrayAlldBlock($currentstruc,$nextblockID,$result);
      }

      return $result;
}

public function blockbtu($currentstruc2,$currentid2,$notebook2){

$CurrentDivisions = Block::where('under_block', '=', NULL )->pluck('id');
$result2 =$notebook2;
$ChildDivisions = Block::whereIn('id',$currentid2)->pluck('under_block');
//$ChildDivisions = Block::whereIn('under_block',$currentid2)->pluck('id'); topdown
//  $ChildDivisions = Block::whereIn('id',$currentid)->pluck('under_block');
//  $ChildDivisions = Block::whereIn('id',$CurrentDivisions )->pluck('id');
foreach ( $ChildDivisions as $Division => $get) {
  $nextblockID2[$Division] = $get;
  $arraylength = sizeof($result2);
  //$currentid=$currentid;
  $result2[$arraylength]  = $nextblockID2[$Division];
  $result2 = $this->blockbtu($currentstruc2,$nextblockID2,$result2);
  }

  return $result2;
}







    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

      //sidebar

  $tree = session()->get('tree');
  //sidebar

      $matchgroups = match_partner_group::with(['Partner_group','Partner'])->paginate(30);

    return view('system-mgmt/match-partner-group/index', ['matchgroups' => $matchgroups,'tree'=>$tree]);
    }



    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
     public function create()
     {

       //sidebar

 $tree = session()->get('tree');
 //sidebar



       $ugroups = Partner_group::all();

       $members = Partner::all();
       $matchgroups = match_partner_group::all();
       $party = DB::table('party')->get();
        return view('system-mgmt/match-partner-group/create', [ 'party' => $party,'ugroups' => $ugroups, 'members' => $members, 'matchgroupss' => $matchgroups,'tree'=>$tree]);

     }

     /**
      * Store a newly created resource in storage.
      *
      * @param  \Illuminate\Http\Request  $request
      * @return \Illuminate\Http\Response
      */
     public function store(Request $request)
     {


       //Partner::findOrFail($request['member_id']); ใช้เพื่อทำให้ก่อนจะบันทึกต้องมีข้อมูลในตารางนี้ด้วย
      // member::findOrFail($request['member_id']);

       $this->validateInput($request,[

      'description' => 'nullable|string|max:60'

      ]);
        match_partner_group::create([
          'partner_id' => $request['partner_id'],
          'partner_group_id' => $request['partner_group_id'],


       ]);


         return redirect ('/admin/match-partner-group');
     }

     /**
      * Display the specified resource.
      *
      * @param  int  $id
      * @return \Illuminate\Http\Response
      */
     public function show($id)
     {
         //
     }

     /**
      * Show the form for editing the specified resource.
      *
      * @param  int  $id
      * @return \Illuminate\Http\Response
      */



     public function edit($id)
     {
       //sidebar

       $tree = session()->get('tree');
       //sidebar

         $matchgroup = match_partner_group::find($id);

         // Redirect to division list if updating division wasn't existed
         if ($matchgroup == null) {
           $matchgroup = match_partner_group::find($id);
           $data = array(
               'matchgroup' => $matchgroup
             );
             return redirect ('/admin/match-partner-group');
           }

           $ugroups = Partner_group::all();
           $members = Partner::all();
           $party = DB::table('party')->get();
         return view('system-mgmt/match-partner-group/edit', ['party' => $party,'matchgroup' => $matchgroup,'ugroups' => $ugroups,'members' => $members,'tree'=>$tree]);
     }

     /**
      * Update the specified resource in storage.
      *
      * @param  \Illuminate\Http\Request  $request
      * @param  int  $id
      * @return \Illuminate\Http\Response
      */
     public function update(Request $request, $id)
     {
         $matchgroup = match_partner_group::findOrFail($id);
         $input = [
           'partner_id' => $request['partner_id'],
           'partner_group_id' => $request['partner_group_id'],
         ];
         $this->validate($request, [

         ]);
         match_partner_group::where('id', $id)
             ->update($input);

         return redirect ('/admin/match-partner-group');
     }

     /**
      * Remove the specified resource from storage.
      *
      * @param  int  $id
      * @return \Illuminate\Http\Response
      */
     public function destroy($id)
     {
         match_partner_group::where('id', $id)->delete();
          return redirect ('/admin/match-partner-group');
     }

     /**
      * Search country from database base on some specific constraints
      *
      * @param  \Illuminate\Http\Request  $request
      *  @return \Illuminate\Http\Response
      */
     public function search(Request $request) {

       //sidebar

 $tree = session()->get('tree');
 //sidebar

          $constraints = [
            'partner.name' => $request['partner_name'],
            'partner_group.name' => $request['group_name'],

             ];

        $matchgroups = $this->doSearchingQuery($constraints);

        $constraints['partner_name'] = $request['partner_name'];
        $constraints['group_name'] = $request['group_name'];
        return view('system-mgmt/match-partner-group/index', ['matchgroups' => $matchgroups, 'searchingVals' => $constraints,'tree'=>$tree]);
     }

     private function doSearchingQuery($constraints) {
                $query = DB::table('match_partner_group')
                ->leftJoin('partner', 'match_partner_group.partner_id', '=', 'partner.id')

               ->leftJoin('partner_group', 'match_partner_group.partner_group_id', '=', 'partner_group.id')

               ->select('match_partner_group.*','match_partner_group.id', 'partner_group.name as group_name', 'partner_group.id as group_id','partner.name as partner_name', 'partner.id as member_id');




         $fields = array_keys($constraints);
         $index = 0;
         foreach ($constraints as $constraint) {
             if ($constraint != null) {
                 $query = $query->where( $fields[$index], 'like', '%'.$constraint.'%');
             }

             $index++;
         }
         return $query->paginate(1000);
     }
     private function validateInput($request) {
         $this->validate($request, [


     ]);
     }
 }

resources/views/system-mgmt/match-partner-group/base.blade.php
@extends('layouts.app-template')
@section('content')
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <h1>
        match-partner-group
      </h1>
      <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> System Mangement</a></li>
        <li class="active">match-partner-group</li>
      </ol>
    </section>
    @yield('action-content')
    <!-- /.content -->
  </div>
@endsection

resources/views/system-mgmt/match-partner-group/create.blade.php
@extends('system-mgmt.match-partner-group.base')

@section('action-content')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Match partner Group</div>
                <div class="panel-body">
                    <form class="form-horizontal" role="form" method="POST" action="{{ route('match-partner-group.store') }}">
                        {{ csrf_field() }}




                        <div class="form-group">
                            <label class="col-md-4 control-label">partner</label>
                            <div class="col-md-6">
                              <select class="form-control" name="partner_id"  id="nameid">
                                <option></option>
                                @foreach($members as $partner)
                                <option value="{{$partner->id}}">{{$partner->name}} {{$partner->lastname}}</option>
                                @endforeach
                              </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-md-4 control-label">Group</label>
                            <div class="col-md-6">
                              <select class="form-control party" name="partner_group_id" >
                                <option></option>
                                @foreach($ugroups as $ug)
                                <option value="{{$ug->id}}">{{$ug->name}}</option>
                                @endforeach
                              </select>
                            </div>
                        </div>




                        <div class="form-group">
                            <div class="col-md-6 col-md-offset-4">
                                <button type="submit" class="btn btn-primary">
                                    Create
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>


<script src="//cdnjs.cloudflare.com/ajax/libs/jquery/2.0.3/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

<script type="text/javascript">

      $("#nameid").select2({
            placeholder: "Select a Name",
            allowClear: true
        });
</script>

<script type="text/javascript">

      $("#memid").select2({
            placeholder: "Select a Name",
            allowClear: true
        });
</script>
<script type="text/javascript">

      $("#par").select2({
            placeholder: "Select a Name",
            allowClear: true
        });
</script>


<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<script type="text/javascript">
    $(document).ready(function(){
        $(document).on('change','.department',function(){
        //  console.log("hmm its change");

            var department_id=$(this).val();
            //console.log(department_id);
            var div=$(this).parent();
            var op=" ";
            $.ajax({
                type:'get',
                url:'{!!URL::to('findDivisionName')!!}',
                data:{'id':department_id},

                success:function(data){
                  console.log('success');

                  console.log(data);

                 console.log(data.length);
                  op+='<option value="0" selected disabled>chose Block</option>';
                  for(var i=0; i<data.length;i++){
                    op+='<option value="'+data[i].id+'">'+data[i].name+'</option>';

                  }
                  div.find('.name').html(" ");
                  div.find('.name').append(op);

                },
                error:function(){

                }
            });
        });
    });
</script>

<script src="//cdnjs.cloudflare.com/ajax/libs/jquery/2.0.3/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>

<script type="text/javascript">

    $(document).ready(function(){
        $(document).on('change','.party',function(){
        //  console.log("hmm its change");

            var department_id=$(this).val();
            //console.log(department_id);
            var div=$(this).parent();
            var op=" ";
            $.ajax({
                type:'get',
                url:'{!!URL::to('findPartyName')!!}',
                data:{'id':department_id},

                success:function(data){
                  console.log('success');

                  console.log(data);

                 console.log(data.length);

                  for(var i=0; i<data.length;i++){
                    op+='<option value="'+data[i].id+'">'+data[i].name+'</option>';

                  }
                  $('.par').html(" ");
                  $('.par').append(op);

                },
                error:function(){

                }
            });
        });

    });
</script>

@endsection

resources/views/system-mgmt/match-partner-group/index.blade.php
@extends('system-mgmt.match-partner-group.base')
@section('action-content')
    <!-- Main content -->
    <section class="content">
      <div class="box">
  <div class="box-header">
    <div class="row">
        <div class="col-sm-8">
          <h3 class="box-title">List of Match</h3>
        </div>
        <div class="col-sm-4">
          <a class="btn btn-primary" href="{{ route('match-partner-group.create') }}">Add New</a>
        </div>
    </div>
  </div>
  <!-- /.box-header -->
  <div class="box-body">
      <div class="row">
        <div class="col-sm-6"></div>
        <div class="col-sm-6"></div>
      </div>
      <form method="POST" action="{{ route('match-partner-group.search') }}">
         {{ csrf_field() }}
           @component('layouts.search', ['title' => 'Search'])
           @component('layouts.two-cols-search-row', ['items' => ['group_name', 'partner_name'],
           'oldVals' => [isset($searchingVals) ? $searchingVals['group_name'] : '', isset($searchingVals) ? $searchingVals['partner_name'] :'']])
           @endcomponent


              @endcomponent
      </form>
    <div id="example2_wrapper" class="dataTables_wrapper form-inline dt-bootstrap">
      <div class="row">
        <div class="col-sm-12">
			<div style="overflow-x:auto;">
          <table id="example2" class="table table-bordered table-hover dataTable" role="grid" aria-describedby="example2_info">
            <thead>
              <tr role="row">


                <th  class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1" aria-label="port: activate to sort column ascending">Partner Group</th>
                <th  class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1" aria-label="port: activate to sort column ascending">Partner Name</th>
                <th >Action</th>
              </tr>
            </thead>
            <tbody>
              {{$matchgroups}}
            @foreach ($matchgroups as $matchid)
                <tr role="row" class="odd">


                  <td>{{ $matchid->Partner_group->name }}</td>
                  @if($matchid->partner_id == NULL || $matchid->partner_id == 0 ||$matchid->partner_id == '')
                    <td></td>
                  @else
                    <td>{{ $matchid->Partner->name }}</td>
                  @endif
                  <td>
                    <form class="row" method="POST" action="{{ route('match-partner-group.destroy', ['id' => $matchid->id]) }}" onsubmit = "return confirm('Are you sure?')">
                        <input type="hidden" name="_method" value="DELETE">
                        <input type="hidden" name="_token" value="{{ csrf_token() }}">
                        <a href="{{ route('match-partner-group.edit', ['id' => $matchid->id]) }}" class="btn btn-warning col-sm-3 col-xs-5 btn-margin">
                        Update
                        </a>
                        <button type="submit" class="btn btn-danger col-sm-3 col-xs-5 btn-margin">
                          Delete
                        </button>
                    </form>
                  </td>
              </tr>
            @endforeach
            </tbody>
            <tfoot>
              <tr>
                <th  class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1" aria-label="port: activate to sort column ascending">Partner Group</th>
                <th  class="sorting" tabindex="0" aria-controls="example2" rowspan="1" colspan="1" aria-label="port: activate to sort column ascending">Partner Name</th>

                <th >Action</th>
              </tr>
            </tfoot>
          </table>
			</div>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-5">
          <div class="dataTables_info" id="example2_info" role="status" aria-live="polite">Showing 1 to {{count($matchgroups)}} of {{count($matchgroups)}} entries</div>
        </div>
        <div class="col-sm-7">
          <div class="dataTables_paginate paging_simple_numbers" id="example2_paginate">
            {{ $matchgroups->links() }}
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- /.box-body -->
</div>
    </section>
    <!-- /.content -->
  </div>
@endsection